--- old/usr/src/cmd/make/bin/doname.cc	2015-05-20 12:01:44.541499507 -0400
+++ new/usr/src/cmd/make/bin/doname.cc	2015-05-20 12:01:44.554490786 -0400
@@ -969,6 +969,14 @@
 			if (dependencies_running) {
 				break;
 			}
+		} else if ((!parallel_ok(dependency->name, false)) &&
+			   (dependencies_running)) {
+			/*
+			 * If we can't execute the current dependency in
+			 * parallel, hold off the dependency processing
+			 * to preserve the order of the dependencies.
+			 */
+			break;
 		} else {
 			timestruc_t	depe_time = file_doesnt_exist;
 
--- old/usr/src/cmd/make/lib/mksh/macro.cc	2015-05-20 12:01:46.214726480 -0400
+++ new/usr/src/cmd/make/lib/mksh/macro.cc	2015-05-20 12:01:46.226513968 -0400
@@ -1224,7 +1224,7 @@
 	if (macro->body.macro.exported) {
 		static char	*env;
 
-		if (!reading_environment && (value != NULL) && value->dollar) {
+		if (!reading_environment && (value != NULL)) {
 			Envvar	p;
 
 			for (p = envvar; p != NULL; p = p->next) {
@@ -1242,7 +1242,7 @@
 			p->already_put = false;
 			envvar = p;
 found_it:;
-		} else {
+		} if (reading_environment || (value == NULL) || !value->dollar) {
 			length = 2 + strlen(name->string_mb);
 			if (value != NULL) {
 				length += strlen(value->string_mb);
